-- DCS - Iron Bombing Range Script
-- Version 1.1

-- Based on original by
-- By Ciribob - https://github.com/ciribob/DCS-SimpleRangeScript
-- Inspired by Original Script by SNAFU http://forums.eagle.ru/showthread.php?t=109174
-- And on the A-4E community range script

trigger.action.outText( 'Iron Bombing Range Script Loaded', 10 )

range  = {} 
range.bombingMinAlt = 0

function addWeapon(event) 
    if event.id ~= world.event.S_EVENT_SHOT or event.weapon == nil then 
        return
    end
    local _weapon = event.weapon:getTypeName()
    trigger.action.outText( 'Fired '.. _weapon, 10 )
    local _ordnance =  event.weapon
    local _lastBombPos = {x=0,y=0,z=0}
    local _unitName = event.initiator:getName()
    local trackBomb = function(_previousPos)
        local _unit = Unit.getByName(_unitName)
        if _unit ~= nil and _unit:getPlayerName() ~= nil then
            -- when the pcall returns a failure the weapon has hit
            local _status,_bombPos =  pcall(function()
                -- env.info("protected")
                return _ordnance:getPoint()
            end)
            if _status then  -- still in the air
                _lastBombPos = {x = _bombPos.x, y = _bombPos.y, z= _bombPos.z }
                return timer.getTime() + 0.005 -- check again !
            else
                local _closetTarget = nil
                local _distance = nil
                local _direction = nil

                for _,_targetZone in pairs(range.bombingTargets) do
                    local _temp = getDistance(_targetZone.point, _lastBombPos)
                    if _distance == nil or _temp < _distance then
                        _distance = _temp
                        _closetTarget = _targetZone
                        _direction = getDirection(_targetZone.point, _lastBombPos)
                    end
                end

                env.info(_distance.." from ".._closetTarget.name.." @".._direction)

                if _distance < 1000 then
                    _DistResult = string.format(" %.1f m from ", _distance)
                    _DirResult = string.format(" bearing %i degrees", _direction)
                    trigger.action.outText(_weapon.._DistResult.._closetTarget.name.._DirResult, 10,10,false)
                    _isMark = trigger.misc.getUserFlag(3)
                    if _isMark == 1 then
                        trigger.action.effectSmokeBig(_lastBombPos, 5,.5)
                    end
                end
            end

        end

    end
    timer.scheduleFunction(trackBomb, nil, timer.getTime() + 1)
end 

function getDistance(_point1, _point2)
    local xDiff = _point1.x - _point2.x
    local yDiff = _point1.z - _point2.z
    local dist = math.sqrt(xDiff * xDiff + yDiff * yDiff)
    return math.max(dist - 9.144, 0) -- minus 30 feet
end

function getDirection(_point1, _point2)
    local tgtBearing
    local xDiff = _point1.x - _point2.x
    local yDiff = _point1.z - _point2.z
    local tgtAngle = math.deg(math.atan(yDiff/xDiff))
    if xDiff > 0 then 
        tgtBearing = 180 + tgtAngle 
    elseif xDiff < 0 and tgtAngle > 0 then
        tgtBearing = tgtAngle 
    elseif xDiff < 0 and tgtAngle < 0 then
        tgtBearing = 360 + tgtAngle
    end
    env.info("xDiff "..xDiff.." yDiff "..yDiff)    
    return tgtBearing
end

local _tempTargets = {
    "target1",
    "target2",
    "target3",
    "target4",
    "target5",
    "target6",
    "target7",
}
range.bombingTargets = {}
for _,_targetZone in pairs(_tempTargets) do
    local _triggerZone = trigger.misc.getZone(_targetZone)
    if _triggerZone then
        table.insert(range.bombingTargets,{name=_targetZone,point=_triggerZone.point})
        env.info("Done for: ".._targetZone)
    else
        env.info("Failed for: ".._targetZone)
    end
end

 
mist.addEventHandler(addWeapon) 